<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" [
  <!ENTITY % htmlpurifier.current SYSTEM "current.ent"> %htmlpurifier.current;
]>
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xml:lang="en">
<head>
  <title>Download - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="description" content="Download HTML Purifier, the standards-compliant HTML filter library." />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, filtering, standards, compliant, w3c, download, zip, tarball, tgz, sig, gpg, gnupg, sha1, hash, checksum" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">Download</h1>

<div id="content">

<p>
  The current version of HTML Purifier is
  <strong>&htmlpurifier.current.version;</strong>, released on
  &htmlpurifier.current.release-date;, and is tested with
  <abbr>PHP</abbr> 5.3 and up (all code is <code>E_STRICT</code>
  compliant). This library is open-source,
  licensed under the <a href="http://www.gnu.org/licenses/lgpl.html"><abbr>LGPL</abbr>
  v2.1+</a>. We offer multiple ways of downloading
  and installing HTML Purifier.  You might also be interested
  in the <a href="https://github.com/Mynigma/HTMLPurifier">Objective C port</a>.
</p>

<div id="toc" class="floated" />

<!--
<h2 id="Errata">Errata</h2>

<p>
  Here is a list of known bugs. These issues have all been fixed in the
  <a href="#NightlyBuilds">trunk</a> unless
  otherwise noted:
</p>

<ul>
</ul>
-->

<h2 id="Standard">Standard</h2>

<p>
  We offer the standard zip and tarball downloads. Download them,
  unzip them, and with a few simple <a href="#Installation">installation</a> steps get
  to using HTML Purifier right away:
</p>

<ul>
    <li><a class="download" href="&url.dl;.tar.gz">HTML Purifier &htmlpurifier.current.version; (.tar.gz)</a> [<a href="&url.dl;.tar.gz.sig">sig</a>]</li>
    <li><a class="download" href="&url.dl;.zip"   >HTML Purifier &htmlpurifier.current.version; (.zip)</a>    [<a href="&url.dl;.zip.sig">sig</a>]</li>
</ul>

<h3 id="Lite">Lite Distribution</h3>

<p>
  No, it's not magically faster. HTML Purifier Lite offers the same
  functionality of HTML Purifier (standard), except that anything not
  essentially to the basic functioning of the library has been stripped
  out: end-user documentation, unit-tests, profiling, maintenance scripts, etc.
  Just the <code>library</code> folder.
</p>

<ul>
    <li><a class="download" href="&url.dl;-lite.tar.gz">HTML Purifier &htmlpurifier.current.version; Lite (.tar.gz)</a> [<a href="&url.dl;-lite.tar.gz.sig">sig</a>]</li>
    <li><a class="download" href="&url.dl;-lite.zip"   >HTML Purifier &htmlpurifier.current.version; Lite (.zip)</a>    [<a href="&url.dl;-lite.zip.sig">sig</a>]</li>
</ul>

<h3 id="Standalone">Standalone Distribution</h3>

<p>
  For those of you who balk at the possibility of a 100+ includes, we also
  offer a conveniently packaged single-file version of HTML Purifier. Well,
  not really, since HTML Purifier does require some auxiliary files in
  order to work (but they are neatly tucked away in a folder named
  <code>standalone</code>). Include <code>HTMLPurifier.standalone.php</code>
  and be done with it!
</p>

<ul>
    <li><a class="download" href="&url.dl;-standalone.tar.gz">HTML Purifier &htmlpurifier.current.version; Standalone (.tar.gz)</a> [<a href="&url.dl;-standalone.tar.gz.sig">sig</a>]</li>
    <li><a class="download" href="&url.dl;-standalone.zip"   >HTML Purifier &htmlpurifier.current.version; Standalone (.zip)</a>    [<a href="&url.dl;-standalone.zip.sig">sig</a>]</li>
</ul>

<h3 id="SHA1"><acronym>SHA-1</acronym> checksums</h3>

<p>
  Here are the <acronym>SHA-1</acronym> checksums you can use to
  verify the integrity of your HTML Purifier download:
</p>

<pre class="long">&htmlpurifier.current.hashes;</pre>

<h3 id="GnuPG">GnuPG signatures</h3>

<p>
  There are <tt>.sig</tt> files which you can use to cryptographically verify
  that the release is from me, Edward Z. Yang.  You can find
  my <a href="http://www.thewritingpot.com/gpgpubkey.asc">public key
  here (0x869C48DA)</a>.  My key's fingerprint is:
  <tt>3FA8 E9A9 7385 B691 A6FC  B3CB A933 BE7D 869C 48DA</tt>.
</p>

<p>Verify files with this command:</p>

<pre class="command">gpg --verify <strong>$filename</strong>.sig</pre>

<p>Future releases will be signed with my new <a href="ezyang-tablet.asc">ezyang@mit.edu</a>
key.  This key is signed by my old key, and you can retrieve the signature
from <a href="http://pgp.mit.edu:11371/pks/lookup?op=vindex&amp;search=0x4B3B9E321E1C674B">pgp.mit.edu</a>.</p>

<h2 id="PEAR"><acronym>PEAR</acronym></h2>

<p>
  HTML Purifier is also available via a <acronym>PEAR</acronym> channel.
  The <acronym>PEAR</acronym> installer is an incredibly powerful and robust
  way to install <abbr>PHP</abbr> packages, and
  does not have to be limited to packages found on
  <a href="http://pear.php.net/">pear.php.net</a>. With
  <acronym>PEAR</acronym>, installing is as simple as these
  two commands in your shell:
</p>

<pre class="command">pear channel-discover htmlpurifier.org
pear install hp/HTMLPurifier</pre>

<p>
  ...and then following the <a href="#Installation">installation instructions</a>.
</p>

<p>
  You can upgrade with:
</p>

<pre class="command">pear upgrade hp/HTMLPurifier</pre>

<h2 id="Composer">Composer</h2>

<p>
  HTML Purifier is available via <a href="https://getcomposer.org/">Composer</a>,
  just run:
</p>

<pre class="command">composer require ezyang/htmlpurifier</pre>

<h2 id="Git">Git</h2>

<p>
  For those who like to live on the edge, you can also grab the latest
  developmental code from our Git
  repository.  Simply execute this command in your shell:
</p>

<pre class="command">git clone git://repo.or.cz/htmlpurifier.git</pre>

<p>
  You must have Git installed. Windows users can grab a copy of Git via the 
  <a href="http://code.google.com/p/msysgit/">msysgit project</a>.
</p>

<p>
  Code in master is quite stable; 
  a combination of extensive unit-testing and atomic commits means that
  the most recent version will almost never be broken.
</p>

<p>
  Online repository browsing and mirroring services (click links to get
  pull URLs) are available at numerous places:
</p>

<ul>
  <li><strong><a href="http://repo.or.cz/w/htmlpurifier.git">repo.or.cz</a></strong> -
    Master repository: prefer pulling from it, always push to it. Make this your
    <code>origin</code> remote if it isn't already.
    <a href="http://repo.or.cz/m/regproj.cgi?name=htmlpurifier/">Allows forks</a>,
    please use them!</li>
  <li><a href="http://gitorious.org/projects/htmlpurifier">Gitorious</a> -
    Regular old mirror. Allows forks, but don't use them.</li>
  <li><a href="http://github.com/ezyang/htmlpurifier/tree/master">GitHub</a> -
    Regular old mirror, but with <a href="http://github.com/ezyang/htmlpurifier/network">pretty
    history visualization tools</a>. Allows forks, but don't use them.</li>
</ul>

<h2 id="Installation">Installation</h2>

<h3>File permissions</h3>

<p>
  HTML Purifier will write
  out cache files for HTMLDefinition in the subdirectories of
  <code>HTMLPurifier/DefinitionCache/Serializer</code>. If you are in
  the <code>library/</code> folder of HTML Purifier, you can set the
  appropriate permissions using:
</p>

<pre class="command">chmod -R 0755 HTMLPurifier/DefinitionCache/Serializer</pre>

<p>
  If the above command doesn't work, you may need to assign write permissions
  to all. This may be necessary if your webserver runs as nobody, but is
  not recommended since it means any other user can write files in the
  directory. Use:
</p>

<pre class="command">chmod -R 0777 HTMLPurifier/DefinitionCache/Serializer</pre>

<p>
  You can also chmod files via your <abbr>FTP</abbr> client; this option
  is usually accessible by right clicking the corresponding directory and
  then selecting <q>chmod</q> or <q>file permissions</q>.
</p>

<p>
  If you are unable or unwilling to give write permissions to the cache
  directory, you can either disable the cache (and suffer a performance
  hit):
</p>

<pre>$config-&gt;set('Core', 'DefinitionCache', null);</pre>

<p>
  Or move the cache directory somewhere else (no trailing slash):
</p>

<pre>$config-&gt;set('Cache', 'SerializerPath', '/home/user/absolute/path');</pre>

<h3>Quick install</h3>

<p>If your website is in UTF-8 and XHTML Transitional, use this code:</p>

<pre>&lt;?php
    require_once '/path/to/htmlpurifier/library/HTMLPurifier.auto.php';
    
    $purifier = new HTMLPurifier();
    $clean_html = $purifier-&gt;purify($dirty_html);
?&gt;</pre>

<p>If your website is in a different encoding or doctype, use this code:</p>

<pre>&lt;?php
    require_once '/path/to/htmlpurifier/library/HTMLPurifier.auto.php';
    
    $config = HTMLPurifier_Config::createDefault();
    $config-&gt;set('Core', 'Encoding', <strong>'ISO-8859-1'</strong>); // replace with your encoding
    $config-&gt;set('HTML', 'Doctype', <strong>'HTML 4.01 Transitional'</strong>); // replace with your doctype
    $purifier = new HTMLPurifier($config);
    
    $clean_html = $purifier-&gt;purify($dirty_html);
?&gt;</pre>

<p>
  People with HTML Purifier already in their path (<acronym>PEAR</acronym>,
  for example) can use:
</p>

<pre>require_once 'HTMLPurifier.auto.php';</pre>

<p>
  For detailed installation instructions, read the
  <a href="http://repo.or.cz/w/htmlpurifier.git?a=blob;f=INSTALL;hb=v&htmlpurifier.current.version;"><code>INSTALL</code></a>
  document.
</p>

<h2 id="MailingList">Mailing list</h2>

<p>
  You can be notified of new releases by a low-traffic announce list. Subscribe
  <a href="https://mailman.mit.edu/mailman/listinfo/htmlpurifier">at the mailman page</a>.
  We take your privacy very seriously and will not use emails submitted
  to this web form for any other purposes.
</p>

<p>
  You can also subscribe to a moderately higher traffic, unmoderated
  mailing list intended for development discussion and user support
  at <a href="http://groups.google.com/group/htmlpurifier">Google Groups</a>.
</p>

<h2 id="History">History</h2>

<p>
  Previous releases can be obtained by browsing
  the <a href="releases/">release directory</a>
  or checking code out of the
  <a href="http://htmlpurifier.org/svnroot/htmlpurifier/tags/">tags/
  directory</a>.  However, they are not supported and should not be used
  in live environments. If you are having trouble upgrading, pop over
  to <a href="http://htmlpurifier.org/phorum/">the forums</a> and get help.
</p>

</div>
</div>

</body>
</html>
